/******************
Universidade Federal de Ouro Preto
Departamento de Computao
Professor: Marcone Jamilson Freitas Souza
Alunos: Eduardo Magno
		Sibele Esteves
******************/

package com272.trabalho;

import java.io.*;
import java.util.*;
import java.lang.*;

public class BuscaTabu {
	public final int MAXINT = 100000;

	public final int MAXPENAL = 100;
	public final int MEDIAPENAL = 20;

    private int tamanhoListaTabu;
    private int maxIteracao;

	Vector job;			// Os processos com peso, lan;
	Vector pc;			// Os computadores com desempenho, mhzAlocado, lanAlocado.
	int nJob;			// Numero de processos no problema
    int nPc;			// Numero de computadores no problema

	int s[];			// Solucao corrente
	int sStar[];		// Melhor solucao encontrada
    int fs;				// Funcao objetivo da solucao corrente
    int fsStar;			// Melhor funcao objetivo encontrada

    int minLan = MAXINT;// valor do menor acesso a rede de um PC
    int maxLan = 0;		// valor do maior acesso a rede de um PC

	ListaMovimento tabu; //Lista com os movimentos proibidos : listaTabu(i) -> Movimento(job, origem, destino)

    public BuscaTabu (int tamLista, int interSemMelhora) {
		tamanhoListaTabu = tamLista;
		maxIteracao = interSemMelhora;
	}

    public BuscaTabu () {
		tamanhoListaTabu = 10;
		maxIteracao = 10;
	}

    public void execute() {
		Movimento mov1opt;
	    int variacao;
	    int numeroIteracao;
	    int iteracaoSemMelhora;

//		s = geraSolInicial();
		s = geraSolInicialAleatorio();
		sStar = new int[nJob];
		for (int i = 0; i < nJob; i++) sStar[i] = s[i];

		System.out.println("SOLUCAO INICIAL");
		for (int i = 0; i < nJob; i++) {
			System.out.print(s[i]);
			System.out.print(" - ");
		}
		System.out.println();

		fs = avaliaSolucao();
		fsStar = fs;

		System.out.println("FUNCAO AVALIACAO INICIAL = " + fs);

		tabu = new ListaMovimento( tamanhoListaTabu );
		numeroIteracao = 0;
		iteracaoSemMelhora = 0;

		while ( iteracaoSemMelhora < maxIteracao ) {
			numeroIteracao++;
			iteracaoSemMelhora++;
			mov1opt = melhorMovimento( s );
			tabu.add( mov1opt );
			variacao = moveJob( mov1opt.getJob(), mov1opt.getDestino() );
			fs = fs + variacao;
			if ( fs < fsStar ) {
				for (int i = 0; i < nJob; i++) sStar[i] = s[i];
				fsStar = fs;
				iteracaoSemMelhora = 0;
			}
			System.out.println("SOLUCAO DA ITERACAO " + numeroIteracao);
			for (int i = 0; i < nJob; i++) {
				System.out.print(s[i]);
				System.out.print(" - ");
			}
			System.out.println();
			System.out.println("FUNCAO AVALIACAO = " + fs);
			System.out.println();
		}
		System.out.println("****************************************");
		System.out.println("MELHOR SOLUCAO ENCONTRADA PELO ALGORITMO");
		System.out.println("****************************************");
		System.out.println("-- MELHOR SOLUCAO --");
		for (int i = 0; i < nJob; i++) {
			System.out.print(sStar[i]);
			System.out.print(" - ");
		}
		System.out.println();
		System.out.println("FUNCAO AVALIACAO = " + fsStar);
		System.out.println();
		System.out.println("Iteracao Sem melhora =" + iteracaoSemMelhora);
		System.out.println("Interacoes feitas =" + numeroIteracao);
	}

// Retorna o melhor vizilho da solucao _sol que no esteja na lista tabu ou satisfaa a funo de aspirao.
	public Movimento melhorMovimento( int[] _sol ) {
		int origem;
		int tempMinLan = minLan;
		int tempMaxLan = maxLan;
		int fmovimento;
		int melhorf = MAXINT;
		Movimento melhorMovimento = new Movimento (0,0);
		Movimento reverso = new Movimento (0,0);
		for (int i = 0; i<nJob; i++) {
			origem = _sol[i];
			for (int j = 0; j<nPc; j++) {
				fmovimento = moveJob( i, j);
				if ( (fmovimento < melhorf) && (origem != j) ) {
					reverso.setJob(i);
					reverso.setDestino(origem);
					if ( !(tabu.contains(reverso)) || ( (fs + fmovimento) < fsStar ) ) {
						melhorf = fmovimento;
						if ( (tabu.contains(reverso)) && ( (fs + fmovimento) < fsStar ) )
							System.out.println(" MOVIMENTO ASPIRADO");
						melhorMovimento.setJob(i);
						melhorMovimento.setDestino(j);
					}
				}
				moveJob( i, origem);
				minLan = tempMinLan;
				maxLan = tempMaxLan;
			}
		}
		return melhorMovimento;
	} // melhorMovimento

	private int radonico (int i ) { // proc_aux: retorna radnio de 0 a i
		int valor = (int) (Math.random() * i);
		return valor;
	}//fim do radonio

// Move o Job _job para o computador _pc e retorna a diferena no valor de fs
	public int moveJob( int _job, int _pc ) {
		Pc pcOld = (Pc)pc.get(s[_job]);
		Pc pcNew = (Pc)pc.get(_pc);
		s[_job] = _pc;
		Job jobMoved = (Job)job.get(_job);
		int f1PcOldB = avaliaF1( pcOld );	// Avalia o pc antes de desalocar o Job
		pcOld.desaloca( jobMoved );			// Retira o Job do Pc
		int f1PcOldA = avaliaF1( pcOld );	// Avalia novamente o Pc para saber quanto mundou em fs
		int f1PcB = avaliaF1( pcNew );		// Avalia o pc antes de alocar o Job
		pcNew.aloca( jobMoved );			// Aloca o Job no novo Pc
		int f1PcA = avaliaF1( pcNew );		// Avalia novamente o Pc para saber quanto mundou em fs
		int f2old = maxLan - minLan;
		if ( minLan > pcOld.getLanAlocado() ) minLan = pcOld.getLanAlocado();
		else {
			minLan = MAXINT;
			int lanPC;
			for (int j = 0; j<nPc; j++) {
				lanPC = ((Pc)pc.get(j)).getLanAlocado();
				minLan = (minLan < lanPC ? minLan : lanPC );
			}
		}
		if ( maxLan < pcNew.getLanAlocado() ) maxLan = pcNew.getLanAlocado();
		else {
			maxLan = 0;
			int lanPC;
			for (int j = 0; j<nPc; j++) {
				lanPC = ((Pc)pc.get(j)).getLanAlocado();
				maxLan = (maxLan > lanPC ? maxLan : lanPC );
			}
		}
		int f2new = maxLan - minLan;
		s[_job] = _pc;
		return (f1PcOldA - f1PcOldB) + (f1PcA - f1PcB) + (f2new - f2old);
	}

// Avalia a Soluo Inicial e retorna fs
	public int avaliaSolucao() {
		int f1 = 0;
		for (int i=0; i < pc.capacity(); i++) f1 = f1 + avaliaF1( (Pc)pc.get(i) );
		int f2 = avaliaF2();
		return f1 + f2;
	}

// Avalia f1 do computador _pc e retorna o valor de f1
	public int avaliaF1( Pc _pc ) {
		int desempenho = _pc.getDesempenho();
		int alocado = _pc.getMhzAlocado();
 		return ( desempenho < alocado ? (desempenho * 1.5 < alocado ? MAXPENAL : MEDIAPENAL ) : 0 );
	}

// Avalia fs, ou seja, encontra o minLan e maxLan no vetor de Pc
	public int avaliaF2() {
		for (int i=0; i < pc.capacity(); i++) {
			int alocado = ( (Pc)pc.get(i) ).getLanAlocado();
			minLan = alocado < minLan ? alocado : minLan;
			maxLan = alocado > maxLan ? alocado : maxLan;
		}
 		return maxLan - minLan;
	}

// Gera uma soluao inicial, alocando ordenadamente os Jobs aos PCs
	public int[] geraSolInicial () {
		int sol[] = new int[job.capacity()];
		int parte = job.capacity() / pc.capacity();
		int resto = job.capacity() % pc.capacity();
		int conta = 0;
		for (int i = 0; i < parte; i++ ) {
			for (int j = 0; j < pc.capacity(); j++ ) {
				( (Pc)pc.get(j) ).aloca((Job)job.get(conta));
				sol[conta] = j;
				conta = conta + 1;
			}
		}
		for (int i = 0; i < resto; i++ ) {
			( (Pc)pc.get(i) ).aloca((Job)job.get(conta));
			sol[conta] = i;
			conta = conta + 1;
		}
		return sol;
	}

// Gera uma soluao inicial, alocando ordenadamente os Jobs aos PCs
	public int[] geraSolInicialAleatorio () {
		int sol[] = new int[job.capacity()];
		int pcEscolhido;
		for (int i = 0; i < nJob; i++ ) {
			pcEscolhido = radonico( nPc );
			( (Pc)pc.get(pcEscolhido) ).aloca((Job)job.get(i));
			sol[i] = pcEscolhido;
		}
		return sol;
	}
}